/*
 Si consideri la Sintassi Astratta sotto, per il Lambda Calcolo:
 Lambda::= Var | Const | [$] Var Lambda | [@] Lambda Lambda
 dove usiamo $ per l'astrazione e @ per l'applicazione.
....
 
 Last.h è un modulo header che insieme a Last.c fornisce l'implementazione
di 5 nuovi tipi:
	VarT, ConstT, AbsT, AppT, LastT
I tipi ide e num possono essere direttamente implementati con i tipi string
e int, in analogia a quanto fatto in laboratorio per i ParseTree in C.
Il tipo LastT introduce alberi astratti il Lambda Calcolo. Questo ipo deve
contenere 4 distinti tipi di alberi astratti per i diversi tipi di termini
del Lambda Calcolo.
In particolare, le operazioni richieste devono inludere:
 mkConst, mkVar, mkAbs, mkApp,
 isConst, isVar, isAbs, isApp
 printAST,
 getIde, getTem, getFun, getArg
*/


//Tipi per definire LastT
typedef struct VarStruct{
    char* name;
}VarT;

typedef struct ConstStruct{
    char* name;
}ConstT;

typedef struct AbsStruct{
    char* name;
    struct LambdaTerm* term;
}AbsT;

typedef struct AppStruct{
    struct LambdaTerm* fun;
    struct LambdaTerm* arg;
}AppT;


union LastStruct{
    VarT V;
    ConstT C;
    AbsT A;
    AppT P;
};
 
typedef enum{Var, Const, Abs, App} lambdaKind;

struct LambdaTerm{
	lambdaKind flag;
	union LastStruct term;
};

typedef struct LambdaTerm * LastT;

//Le operazioni su LastT:
// mkConst, mkVar, mkAbs, mkApp, isConst, isVar, isAbs,
// isApp, printAST, getBind, getTerm, getFun, getArg

typedef enum {false,true} bool;

LastT mkConst(char* c);
LastT mkVar(char* x);
LastT mkAbs(char* x,LastT t);
LastT mkApp(LastT t1, LastT t2);
bool isConst(LastT t);
bool isVar(LastT t);
bool isAbs(LastT t);
bool isApp(LastT t);
void printAST(LastT t);
char* getIde(LastT t);
LastT getTerm(LastT t);
LastT getFun(LastT t);
LastT getArg(LastT t); 





